﻿Imports System.Collections.Generic
Imports System.Text
Imports System.IO
Imports System.Collections
Imports System.Collections.Specialized
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System
Imports System.Drawing.Drawing2D
Imports System.Drawing.Image
Imports System.Threading

Public Class BatchCrop
    Dim OriginalGif As Image
    Dim NameToUse As String = "Frame"
    Dim ImgForSepia As Image

    Dim W, H As Integer
    Dim ImageArray, MemPic, WorkAry As New ArrayList
    Dim N As Integer = 0
    Dim Start, Finish As Integer 'For Selecting A Range Of Frames

    Dim InitX As Integer = 0 'Top Left corner of crop
    Dim InitY As Integer = 0
    Dim Pictures As Integer = 0 'Frames Counter
    'bitmap to contain the cropped image
    Dim cropBitmap As Bitmap
    Dim Im As Image 'Splash
    'the position and size to crop the image file
    Dim Xcropping As Integer
    Dim Ycropping As Integer
    Dim CroppingW As Integer
    Dim CroppingH As Integer
    Dim XStretching As Double = 1
    Dim YStretching As Double = 1
    Dim rect As Rectangle
    'create a pen object
    Public Marker As Pen
    Dim NewName As String

    'select a default crop line size
    Public MarkerSize As Integer = 2

    'will contain the dashStyle of the pen
    Public crpStyle As Drawing2D.DashStyle = Drawing2D.DashStyle.Solid

    'set a default crop line color
    Public MarkerColor As Color = Color.Red
    Dim tt As New ToolTip
    Dim WasAnError As Boolean = False

    Private _numberPreviewImages As Integer = 100
    Private _imageSize As Integer = 100 '75

    Dim Position As Integer = 0 'Where Are We On ImageArray When Clicking A Cell

    Private Sub Form1_Load1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        tt.ShowAlways = True
        tt.AutoPopDelay = 3000
        tt.InitialDelay = 1000
        tt.ReshowDelay = 2000
        tt.SetToolTip(ckSlide, "When Checked Assembles Animation" & vbNewLine & "With Long Delay As Slide Show")
        tt.SetToolTip(ckFlip, "Flips Images Around Vertical Axis")
        tt.SetToolTip(ckGhost, "When Checked, Intends To Get The Edges Of The Images," & vbNewLine & "Works Together With The Tracklbar Below It." & vbNewLine & "WARNING, It's Very Slow!!!")
        tt.SetToolTip(ckJoin, "Joins Two Or More Animations. Please Check For Dimensions. The Frame Size" & vbNewLine & "Is Determined By First Gif And The Others Will Be Padded Or Clipped")
        tt.SetToolTip(ckDark, "Lightens Or Darkens Images")
        tt.SetToolTip(rbNormal, "When Checked Images Mantain Original Color, Except For Ghost")
        tt.SetToolTip(rbGrayScale, "When Checked, Inmages Are Changed To Grayscale")
        tt.SetToolTip(rbSepiaTone, "When Checked, Inmages Are Changed To Sepia Shades")
        tt.SetToolTip(btnExtract, "Click To Extract Frames" & vbNewLine & "And Enable Controls")
        tt.SetToolTip(tbTolerance, "Works Witth CheckBox Above, & vbnewline" & "To Set Tolerance On Edge Detection")
        tt.SetToolTip(btnAnimate, "Assembles Images To Gif Animation" & vbNewLine & "Same Size, But With Settings Above")
        tt.SetToolTip(btnReverse, "Reverses Motion")
        tt.SetToolTip(btnCrop, "Crops The Rectangular Area" & vbNewLine & "Selected With Mouse On PictureBox1," & vbNewLine & "Repeats For All The Other Frames" & vbNewLine & "Assembles Animation")
        tt.SetToolTip(btn75, "Resizes To 75% The Animation")
        tt.SetToolTip(btn50, "Resizes Animation To 50%")
        tt.SetToolTip(btn33, "Resizes Animation To 33%")
        tt.SetToolTip(btn25, "Resizes Animation To 25%")
        tt.SetToolTip(btn150, "Resizes Animation To 150%")
        tt.SetToolTip(btn200, "Resizes Animation To 200%")
        tt.SetToolTip(btnBack, "View Former Frame")
        tt.SetToolTip(btnForward, "View Next Frame")
        tt.SetToolTip(btnStart, "Start Selection For A Subset Of Images")
        tt.SetToolTip(btnEnd, "Last Image Of Subset Selection")
        tt.SetToolTip(btnDelete, "Eliminate This Frame From Animation")
        tt.SetToolTip(lblTour, "Frame Sequence")
        tt.SetToolTip(lbOutput, "Name Of Animation Generated")
        tt.SetToolTip(lblInfo, "Information On Image Cropping")
        tt.SetToolTip(cbType, "Select Extract File Type")
        tt.SetToolTip(tbName, "Type Name Prefix")
        tt.SetToolTip(btnForward, "Call Crop And Resizing Form")
        tt.SetToolTip(btnCrop, "Extract Frames To Image Files")
        tt.SetToolTip(tbName, "Imput Base Name For Your Generated Images")
        tt.SetToolTip(plDoIt, "WARNING! When Playing With These Buttons" & vbNewLine & "Yo Will Generate Several Files In Your Output Folder.")
        tt.BackColor = Color.AliceBlue
        ' tt.ForeColor = Color.Red

        cbType.Items.Add(".Bmp")
        cbType.Items.Add(".Gif")
        cbType.Items.Add(".Jpg")
        cbType.Items.Add(".Png")
        cbType.Items.Add(".Tif")
        ImageArray = New ArrayList
        MemPic = New ArrayList
        cbType.SelectedIndex = 2
        OriginalGif = pbSelect.Image

    End Sub

    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        Dim f As New OpenFileDialog
        Try
            With f
                .Filter = "Gif Files|*.gif"

                If .ShowDialog = DialogResult.OK Then
                    OriginalGif = Image.FromFile(.FileName)
                    pbPreview.Image = Image.FromFile(.FileName)

                    If ImageArray IsNot Nothing Then
                        If ckJoin.Checked = False Then ImageArray.Clear() 'For joining
                    End If

                    plDoIt.Enabled = False
                    plSelect.Enabled = False
                    N = 0
                    Me.Text = "Gif Processor -> " & .FileName.Substring(.FileName.LastIndexOf("\") + 1)

                End If

            End With

        Catch ex As Exception
            MessageBox.Show(ex.ToString)

        Finally
            If Not f Is Nothing Then
                f.Dispose()
                f = Nothing
            End If
        End Try
        pbPreview.Visible = True
        pbSelect.Visible = False
        pbPreview.BringToFront()
    End Sub

    Public Sub Rip(ByVal Prefix As String)

        If ckJoin.Checked = False Then 'For joining
            ImageArray.Clear()
            MemPic.Clear()
        End If

        Dim Picture As Image
        Dim MS As MemoryStream
        Dim Buf As Byte()
        Dim TempName As String
        Dim OrigDim As New FrameDimension(OriginalGif.FrameDimensionsList(0))
        Dim FrameCount As Integer = OriginalGif.GetFrameCount(OrigDim)
        ' Dim MemStr As Bitmap
        For i As Integer = 0 To FrameCount - 1
            OriginalGif.SelectActiveFrame(OrigDim, i)
            MS = New MemoryStream
            Using Frames As New Bitmap(OriginalGif)
                TempName = GetNewName(Prefix, cbType.Text)
                ImageArray.Add(TempName)
                Frames.Clone.Save(MS, ImageFormat.Jpeg)
                Buf = MS.ToArray
                Picture = BytesToBitmap(Buf)

                MemPic.Add(Picture)
                MS.SetLength(0)
                Select Case Trim(cbType.Text.ToUpper)
                    Case ".BMP"
                        Frames.Save(GetNewName(Prefix, cbType.Text), ImageFormat.Bmp)
                    Case ".JPG"
                        Frames.Save(GetNewName(Prefix, cbType.Text), ImageFormat.Jpeg)
                    Case ".GIF"
                        Frames.Save(GetNewName(Prefix, cbType.Text), ImageFormat.Gif)
                    Case ".PNG"
                        Frames.Save(GetNewName(Prefix, cbType.Text), ImageFormat.Png)
                    Case ".TIF"
                        Frames.Save(GetNewName(Prefix, cbType.Text), ImageFormat.Tiff)
                End Select

            End Using

        Next


    End Sub

    Public Shared Function BytesToBitmap(ByVal byteArray As Byte()) As Bitmap

        Using ms As New MemoryStream(byteArray)
            Dim img As Bitmap = DirectCast(Image.FromStream(ms), Bitmap)
            Return img
        End Using

    End Function
    Private Sub Save(ByVal Pic As Image)
        Dim i As Integer
        Dim str As String = ""
        For i = 1 To 1000
            If i < 10 Then str = "Pic_00" & i.ToString & ".gif"
            If i > 9 And i < 100 Then str = "Pic_0" & i.ToString & ".gif"
            If i > 99 Then str = "Pic_" & i.ToString & ".gif"
            If i > 900 Then MessageBox.Show("You Have Over 900 Pictures, Please Check And Delete Unnecessary Ones")
            If Not System.IO.File.Exists(str) Then
                Try
                    Pic.Save(str, System.Drawing.Imaging.ImageFormat.Gif)
                Catch Ex As Exception
                    MessageBox.Show("Could Not Write To Location")
                End Try
                Exit For
            End If
        Next

    End Sub
    Private Function CropImage(ByVal Orig_Pic As Image) As Image
        ' Get the source Bmp.
        If CroppingW <= 0 Or CroppingH <= 0 Then
            MessageBox.Show("Please Select Again")
            WasAnError = True
            Return pbSelect.Image
        End If
        Dim Orig_bmp As New Bitmap(Orig_Pic)

        ' Create the destination Bmp.
        Dim TheWidth As Integer = CroppingW '.Image.Width
        Dim TheHeight As Integer = CroppingH 'PbCrop.Image.Height
        Dim Dest_bmp As New Bitmap(TheWidth, TheHeight, Orig_Pic.PixelFormat)
        Dim G As Graphics = Graphics.FromImage(Dest_bmp)

        ' Copy the image.
        G.InterpolationMode = Drawing2D.InterpolationMode.HighQualityBilinear
        G.DrawImage(Orig_bmp, -InitX, -InitY, W, H)

        G.Dispose()
        Return Dest_bmp 'Cropped image

    End Function



    Private Sub pbSelect_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbSelect.MouseDown
        InitX = e.X
        InitY = e.Y
        pbResult.Visible = False
        Try

            If e.Button = MouseButtons.Left Then

                Xcropping = e.X
                Ycropping = e.Y
                Marker = New Pen(MarkerColor, MarkerSize)
                Marker.DashStyle = crpStyle
                'change the mouse pointer to the cross cursor which kinda helps when
                'sizing for the crop
                Cursor = Cursors.Cross

            End If

            'clear the previous crop lines by clicking on the pic
            pbSelect.Refresh()


        Catch exc As Exception

            MessageBox.Show(exc.Message, " Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub PictureBox1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbSelect.MouseMove
        If Not e.Button = MouseButtons.Left Then Exit Sub

        Try

            If pbSelect.Image Is Nothing Then Exit Sub

            If e.Button = MouseButtons.Left Then

                pbSelect.Refresh() 'clear the previous drawn crop lines

                'where the mouse started at and calculate the new position
                CroppingW = e.X - Xcropping
                CroppingH = e.Y - Ycropping
            End If

            'draw the outline for the cropping
            pbSelect.CreateGraphics.DrawRectangle(Marker, Xcropping, Ycropping, CroppingW, CroppingH)
            GC.Collect()

        Catch exc As Exception

            'this is a error when the cropping parameters are less than 1
            If Err.Number = 5 Then Exit Sub

            MessageBox.Show(exc.Message, " Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

        End Try
        lblInfo.Text = "Frames = " & ImageArray.Count.ToString & vbNewLine & "Point(" & InitX.ToString & "," & InitY.ToString & ")" & vbNewLine & "W= " & pbResult.Width.ToString & ", H= " & pbResult.Height.ToString
    End Sub

    Private Sub PictureBox1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbSelect.MouseUp
        Try
            'change the mouse pointer back to the default cursor
            Cursor = Cursors.Default

        Catch exc As Exception

            MessageBox.Show(exc.Message, " Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

        End Try
        '------------------------------
        Try

            If CroppingW < 1 Then

                'if there are not proper cropping cordinates, then throw a message and exit code
                MessageBox.Show("Please select the area crop.", " No cropping Cordinates!", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub

            End If

            'a rectangle to set the location and size from the source image
            If pbSelect.SizeMode = PictureBoxSizeMode.Normal Then
                rect = New Rectangle(Xcropping, Ycropping, CroppingW, CroppingH)

            Else
                rect = New Rectangle(Xcropping * XStretching, Ycropping * YStretching, CroppingW * XStretching, CroppingH * YStretching)
            End If
            Dim bit As Bitmap = New Bitmap(pbSelect.Image, pbSelect.Width, pbSelect.Height)

            cropBitmap = New Bitmap(CroppingW, CroppingH)

            Dim g As Graphics = Graphics.FromImage(cropBitmap)

            g.DrawImage(bit, 0, 0, rect, GraphicsUnit.Pixel)


            pbResult.Image = cropBitmap 'Make changes permanent



        Catch exc As Exception

            MessageBox.Show(exc.ToString)

        End Try
        ' PictureBox1.Refresh()
        lblInfo.Text = "Frames = " & ImageArray.Count.ToString & vbNewLine & "Point(" & InitX.ToString & "," & InitY.ToString & ")" & vbNewLine & "W= " & pbResult.Width.ToString & ", H= " & pbResult.Height.ToString
        pbResult.Visible = True
    End Sub

    Private Sub btnForward_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnForward.Click
        'View Jpg Files in Directory
        If ImageArray.Count = 1 Then Exit Sub
        N += 1
        If N > ImageArray.Count - 1 Then
            N = 0
        End If
        If ImageArray(N) IsNot Nothing Then
            pbSelect.Image = Image.FromFile(ImageArray(N))
        End If
        lblTour.Text = ImageArray(N) & vbNewLine & "Image(" & N & ")"
        Hilite()
    End Sub

    Private Sub btnBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBack.Click
        'View Jpg Files in Directory
        If ImageArray.Count = 1 Then Exit Sub

        N = N - 1
        If N < 0 Then
            N = ImageArray.Count - 1

        End If
        If ImageArray(N) IsNot Nothing Then
            pbSelect.Image = Image.FromFile(ImageArray(N))
        End If

        lblTour.Text = ImageArray(N) & vbNewLine & "Image(" & N & ")"
        Hilite()
    End Sub
    Private Sub File_Rename(ByVal OldName As String)
        'Frame3.jpg
        If OldName.Length > 12 Then Exit Sub 'Already processed

        Dim NewFname As String = ""
        Dim Len As Integer
        Dim Ending = OldName.Substring(5)
        Len = Ending.Length
        Try
            Select Case Len

                Case 5
                    NewFname = "Frame000" & Ending
                Case 6
                    NewFname = "Frame00" & Ending
                Case 7
                    NewFname = "Frame0" & Ending
                Case 8
                    NewFname = "Frame" & Ending

            End Select

            My.Computer.FileSystem.RenameFile(OldName, NewFname)
        Catch
            MessageBox.Show("We Got An Error")
        End Try


    End Sub


    Public Sub Assemble(ByVal But As Integer)
        Me.Cursor = Cursors.WaitCursor
        'Variable declaration
        Dim memoryStream As MemoryStream
        Dim binaryWriter As BinaryWriter
        Dim image As Image
        Dim buf1 As [Byte]()
        Dim buf2 As [Byte]()
        Dim buf3 As [Byte]()
        memoryStream = New MemoryStream()
        buf2 = New [Byte](18) {}
        buf3 = New [Byte](7) {}
        buf2(0) = 33
        'extension introducer
        buf2(1) = 255
        'application extension
        buf2(2) = 11
        'size of block
        buf2(3) = 78
        'N
        buf2(4) = 69
        'E
        buf2(5) = 84
        'T
        buf2(6) = 83
        'S
        buf2(7) = 67
        'C
        buf2(8) = 65
        'A
        buf2(9) = 80
        'P
        buf2(10) = 69
        'E
        buf2(11) = 50
        '2
        buf2(12) = 46
        '.
        buf2(13) = 48
        '0
        buf2(14) = 3
        'Size of block
        buf2(15) = 1
        '
        buf2(16) = 0
        '
        buf2(17) = 0
        '
        buf2(18) = 0
        'Block terminator
        buf3(0) = 33
        'Extension introducer
        buf3(1) = 249
        'Graphic control extension
        buf3(2) = 4
        'Size of block
        buf3(3) = 9
        'Flags: reserved, disposal method, user input, transparent color
        buf3(4) = 10 ' 88 
        If ckSlide.Checked = True Then
            'Delay time low byte
            buf3(5) = 1
            'Delay time high byte
            buf3(6) = 0
        Else
            'Delay time low byte
            buf3(5) = 0 '1 
            'Delay time high byte
            buf3(6) = 255
        End If

        'Transparent color index
        buf3(7) = 0
        'Block terminator

        NewName = GetNewName1()
        lbOutput.Text = NewName
        binaryWriter = New BinaryWriter(File.Open(NewName, FileMode.Create))

        For picCount As Integer = 0 To ImageArray.Count - 1 'stringCollection.Count - 1

            Select Case But
                Case 1
                    'Animate
                    image = Bitmap.FromFile(ImageArray(picCount))
                    If ckDark.Checked = True Then image = Dark(image)
                    If rbSepiaTone.Checked = True Then image = Sepia(image)
                    If rbGrayScale.Checked = True Then image = Grayscale(image)
                    If ckGhost.Checked = True Then Ghost(image)
                    If ckFlip.Checked = True Then image.RotateFlip(RotateFlipType.RotateNoneFlipX)
                Case 2
                    If MemPic IsNot Nothing Then
                        image = MemPic(picCount)
                        If ckDark.Checked = True Then image = Dark(image)
                        If rbSepiaTone.Checked = True Then image = Sepia(image)
                        If rbGrayScale.Checked = True Then image = Grayscale(image)
                        If ckGhost.Checked = True Then Ghost(image)
                        If ckFlip.Checked = True Then image.RotateFlip(RotateFlipType.RotateNoneFlipX)
                    Else
                        MessageBox.Show("Please Select Something")
                    End If

            End Select
            image.Save(memoryStream, ImageFormat.Gif)
            buf1 = memoryStream.ToArray()

            If picCount = 0 Then
                'only write these the first time....
                binaryWriter.Write(buf1, 0, 781)
                'Header & global color table
                'Application extension
                binaryWriter.Write(buf2, 0, 19)
            End If
            binaryWriter.Write(buf3, 0, 8)
            'Graphic extension
            binaryWriter.Write(buf1, 781, buf1.Length - 782)
            'Image data
            ' If picCount = stringCollection.Count - 1 Then
            If picCount = ImageArray.Count - 1 Then
                'only write this one the last time....
                'Image terminator
                binaryWriter.Write(";")
            End If


            memoryStream.SetLength(0)
            Progress.Value = 100 * picCount / ImageArray.Count
        Next

        binaryWriter.Close()
        pbSelect.Invalidate()
        memoryStream.Close()
        Me.Cursor = Cursors.Default
        pbSelect.Image = image.FromFile(ImageArray(N))
        pbSelect.Refresh()
        Progress.Value = 0
    End Sub

    Public Function GetNewName1() As String
        Dim i As Integer
        Dim str As String = ""
        For i = 1 To 1000
            If i < 10 Then str = "Animation_00" & i.ToString & ".gif"
            If i > 9 And i < 100 Then str = "Animation_0" & i.ToString & ".gif"
            If i > 99 Then str = "Animation_" & i.ToString & ".gif"
            If i > 900 Then MessageBox.Show("You Have Over 900 Pictures, Please Check And Delete Unnecessary Ones")
            If Not System.IO.File.Exists(str) Then
                Exit For
            End If
        Next
        Return str
    End Function

    Private Sub btnAnimate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAnimate.Click
        Assemble(1)
        pbResult.Image = Image.FromFile(NewName)

    End Sub

    Private Sub btnCrop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCrop.Click
        MemPic.Clear()
        If pbResult.Image IsNot Nothing Then
            Dim TempImage As Image

            For Each N As Object In ImageArray
                W = GetImageWidth(N)
                H = GetImageHeight(N)
                TempImage = CropImage(Image.FromFile(N))
                If WasAnError = True Then
                    MemPic.Clear()
                    WasAnError = False
                    Exit Sub
                Else
                    MemPic.Add(TempImage)
                End If

            Next
            Assemble(2)
        Else
            MessageBox.Show("Select Something, Please")
            Exit Sub
        End If
        pbResult.Image = Image.FromFile(NewName)

    End Sub

    Private Sub scan()
        ImageArray.Clear()
        Try
            Dim di As New IO.DirectoryInfo(Environment.CurrentDirectory)
            Dim aryFi As IO.FileInfo() = di.GetFiles("*.jpg")
            Pictures = aryFi.Count
            Dim fi As IO.FileInfo
            For Each fi In aryFi
                File_Rename(fi.Name)
            Next
            Dim aryFi2 As IO.FileInfo() = di.GetFiles("*.jpg")

            For Each fi In aryFi2
                ImageArray.Add(fi.Name) 'Original jpg Files 

            Next

            If ImageArray IsNot Nothing Then
                ImageArray.Sort()
                If ImageArray(0) IsNot Nothing Then
                    pbSelect.Image = Image.FromFile(ImageArray(0))
                    Im = pbSelect.Image.Clone
                    lblTour.Text = ImageArray(0)
                End If
            End If
        Catch
            MessageBox.Show("Didn't Find Any Jpg Fles In Directory, Sorry")
        End Try
    End Sub

    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        ImageArray.RemoveAt(N)
        LoadImages()
    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        Start = N
    End Sub

    Private Sub btnEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnd.Click
        Finish = N
        WorkAry.Clear()
        For i As Integer = Start To Finish
            WorkAry.Add(ImageArray(i))
        Next
        ImageArray.Clear()
        For i As Integer = 0 To WorkAry.Count - 1

            ImageArray.Add(WorkAry(i))
        Next
        N = ImageArray.Count - 1
    End Sub

    Private Sub btnReverse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReverse.Click
        ImageArray.Reverse()
        Assemble(1)
        pbResult.Image = Image.FromFile(NewName)

    End Sub


    Private Sub btnResize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn50.Click, btn33.Click, btn25.Click, btn150.Click, btn75.Click, btn200.Click
        Dim Orig_bmp As Bitmap
        'following code resizes pictures
        MemPic.Clear()
        For NX As Integer = 0 To ImageArray.Count - 1
            W = GetImageWidth(ImageArray(0))
            H = GetImageHeight(ImageArray(0))

            If rbNormal.Checked = True Then
                Orig_bmp = New Bitmap(Image.FromFile(ImageArray(NX)))

            ElseIf rbGrayScale.Checked = True Then
                Orig_bmp = New Bitmap(Grayscale((Image.FromFile(ImageArray(NX)))))

            ElseIf rbSepiaTone.Checked = True Then
                Orig_bmp = New Bitmap(Sepia(Image.FromFile(ImageArray(NX))))
            Else
                ' Orig_bmp = New Bitmap(Dark(Image.FromFile(ImageArray(NX))))

            End If
            Dim x, y As Integer


            If sender Is btn50 Then
                x = W / 2
                y = H / 2
            End If

            If sender Is btn33 Then
                x = W / 3
                y = H / 3
            End If

            If sender Is btn25 Then
                x = W / 4
                y = H / 4
            End If

            If sender Is btn150 Then
                x = W * 3 / 2
                y = H * 3 / 2
            End If
            If sender Is btn75 Then
                x = W * 3 / 4
                y = H * 3 / 4
            End If
            If sender Is btn200 Then
                x = W * 2
                y = H * 2
            End If

            ' Dim Small As New Bitmap(Width, Height)
            Dim Small As New Bitmap(x, y)
            Dim G As Graphics = Graphics.FromImage(Small)

            G.InterpolationMode = Drawing2D.InterpolationMode.HighQualityBicubic
            G.DrawImage(Orig_bmp, New Rectangle(0, 0, x, y), New Rectangle(0, 0, Orig_bmp.Width, Orig_bmp.Height), GraphicsUnit.Pixel)

            G.Dispose()
            MemPic.Add(Small)

        Next
        Assemble(2)
        pbResult.Image = Image.FromFile(NewName)
        Refresh()
    End Sub


    Private Function Ghost(ByVal img) As Image
        Dim countx, county As Integer
        Dim Tol As Integer = tbTolerance.Value '30

        Try
            Dim rect As Rectangle = Rectangle.Round(img.GetBounds(GraphicsUnit.Pixel))
            Dim TheWidth As Integer = img.Width
            Dim TheHeight As Integer = img.Height
            Dim bmpSr As BitmapData = img.LockBits(New Rectangle(0, 0, img.Width, img.Height), ImageLockMode.ReadWrite, img.PixelFormat)

            Dim ptrSr As IntPtr = bmpSr.Scan0
            Dim R, G, B, A, A1, A2, A3, A4 As Integer
            R = 2
            G = 1
            B = 0
            A = 3
            Dim bytesSr As Integer = bmpSr.Stride * img.Height
            Dim rgbvaluesSr(bytesSr) As Byte
            System.Runtime.InteropServices.Marshal.Copy(ptrSr, rgbvaluesSr, 0, bytesSr)
            'For i As Integer = 0 To rgbvaluesSr.Length - 4 Step 4
            For county = 0 To img.Height - 2
                If img.PixelFormat = System.Drawing.Imaging.PixelFormat.Format24bppRgb Then
                    For countx = county * bmpSr.Stride To (county + 1) * bmpSr.Stride - 6 Step 3
                        A1 = CInt(rgbvaluesSr(countx + R)) + CInt(rgbvaluesSr(countx + G)) + CInt(rgbvaluesSr(countx + B))
                        A2 = CInt(rgbvaluesSr(countx + 3 + R)) + CInt(rgbvaluesSr(countx + 3 + G)) + CInt(rgbvaluesSr(countx + 3 + B))
                        A3 = CInt(rgbvaluesSr(countx + R + bmpSr.Stride)) + CInt(rgbvaluesSr(countx + G + bmpSr.Stride)) + CInt(rgbvaluesSr(countx + B + bmpSr.Stride))
                        A4 = CInt(rgbvaluesSr(countx + 3 + R + bmpSr.Stride)) + CInt(rgbvaluesSr(countx + 3 + G + bmpSr.Stride)) + CInt(rgbvaluesSr(countx + 3 + B + bmpSr.Stride))

                        'If (A2 - A1) > Tol Or (A3 - A1) > Tol Or (A4 - A1) > Tol Then
                        If Math.Abs(A2 - A1) > Tol Or Math.Abs(A3 - A1) > Tol Or Math.Abs(A4 - A1) > Tol Then

                            ' Comment Next Lines To Get Color Edges

                            rgbvaluesSr(countx + R) = 0
                            rgbvaluesSr(countx + G) = 0
                            rgbvaluesSr(countx + B) = 0


                        Else
                            rgbvaluesSr(countx + R) = 255
                            rgbvaluesSr(countx + G) = 255
                            rgbvaluesSr(countx + B) = 255

                        End If
                        If countx = (county + 1) * bmpSr.Stride - 6 Then
                            'Dark Line To the Right
                            rgbvaluesSr(countx + R + 4) = 255
                            rgbvaluesSr(countx + G + 4) = 255
                            rgbvaluesSr(countx + B + 4) = 255
                            rgbvaluesSr(countx + R + 8) = 255
                            rgbvaluesSr(countx + G + 8) = 255
                            rgbvaluesSr(countx + B + 8) = 255
                            rgbvaluesSr(countx + R + 12) = 255
                            rgbvaluesSr(countx + G + 12) = 255
                            rgbvaluesSr(countx + B + 12) = 255

                        End If
                    Next countx

                ElseIf img.PixelFormat = System.Drawing.Imaging.PixelFormat.Format32bppArgb Then
                    For countx = county * bmpSr.Stride To (county + 1) * bmpSr.Stride - 8 Step 4
                        A1 = CInt(rgbvaluesSr(countx + R)) + CInt(rgbvaluesSr(countx + G)) + CInt(rgbvaluesSr(countx + B))
                        A2 = CInt(rgbvaluesSr(countx + 4 + R)) + CInt(rgbvaluesSr(countx + 4 + G)) + CInt(rgbvaluesSr(countx + 4 + B))
                        A3 = CInt(rgbvaluesSr(countx + R + bmpSr.Stride)) + CInt(rgbvaluesSr(countx + G + bmpSr.Stride)) + CInt(rgbvaluesSr(countx + B + bmpSr.Stride))
                        A4 = CInt(rgbvaluesSr(countx + 4 + R + bmpSr.Stride)) + CInt(rgbvaluesSr(countx + 4 + G + bmpSr.Stride)) + CInt(rgbvaluesSr(countx + 4 + B + bmpSr.Stride))

                        'If (A2 - A1) > Tol Or (A3 - A1) > Tol Or (A4 - A1) > Tol Then
                        If Math.Abs(A2 - A1) > Tol Or Math.Abs(A3 - A1) > Tol Or Math.Abs(A4 - A1) > Tol Then

                            rgbvaluesSr(countx + A) = 255
                            rgbvaluesSr(countx + R) = 0
                            rgbvaluesSr(countx + G) = 0
                            rgbvaluesSr(countx + B) = 0


                        Else
                            rgbvaluesSr(countx + A) = 255
                            rgbvaluesSr(countx + R) = 255
                            rgbvaluesSr(countx + G) = 255
                            rgbvaluesSr(countx + B) = 255

                        End If
                        If countx = (county + 1) * bmpSr.Stride - 8 Then
                            'Dark Line To the Right
                            rgbvaluesSr(countx + A + 4) = 255
                            rgbvaluesSr(countx + R + 4) = 255
                            rgbvaluesSr(countx + G + 4) = 255
                            rgbvaluesSr(countx + B + 4) = 255
                            rgbvaluesSr(countx + A + 8) = 255
                            rgbvaluesSr(countx + R + 8) = 255
                            rgbvaluesSr(countx + G + 8) = 255
                            rgbvaluesSr(countx + B + 8) = 255
                            rgbvaluesSr(countx + A + 12) = 255
                            rgbvaluesSr(countx + R + 12) = 255
                            rgbvaluesSr(countx + G + 12) = 255
                            rgbvaluesSr(countx + B + 12) = 255

                        End If
                    Next countx
                Else
                    MessageBox.Show("No Provisions Fot This Format")
                End If


            Next county
            System.Runtime.InteropServices.Marshal.Copy(rgbvaluesSr, 0, ptrSr, bytesSr)

            img.UnlockBits(bmpSr)
        Catch
            MessageBox.Show("Error")
        End Try
        Return img

    End Function

    Private Sub ckGhost_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckGhost.CheckedChanged
        If ckGhost.Checked = True Then

            tbTolerance.Visible = True
        Else
            tbTolerance.Visible = False
        End If

    End Sub

    Public Shared Function ConvertToRGB(ByVal original As Bitmap) As Bitmap
        Dim newImage As New Bitmap(original.Width, original.Height, System.Drawing.Imaging.PixelFormat.Format32bppArgb)
        newImage.SetResolution(original.HorizontalResolution, original.VerticalResolution)
        Dim g As Graphics = Graphics.FromImage(newImage)
        g.DrawImageUnscaled(original, 0, 0)
        g.Dispose()
        Return newImage
    End Function
    Public Function GetNewName(ByVal Prefix As String, ByVal Suffix As String) As String
        Dim i As Integer
        Dim str As String = ""
        For i = 0 To 10000
            If i < 10 Then str = Prefix & "000" & i.ToString & Suffix
            If i > 9 And i < 100 Then str = Prefix & "00" & i.ToString & Suffix
            If i > 99 And i < 1000 Then str = Prefix & "0" & i.ToString & Suffix
            If i > 999 Then str = Prefix & i.ToString & Suffix
            If Not System.IO.File.Exists(str) Then
                Exit For
            End If
        Next
        Return str
    End Function


    Private Function Sepia(ByVal img) As Image
        Dim image_attr As New ImageAttributes
        ' Dim img As Image
        '~29%,57%,14%


        Dim cmy As ColorMatrix = New ColorMatrix(New Single()() _
        { _
        New Single() {0.32645, 0.29305, 0.22633, 0.0, 0.0}, _
        New Single() {0.64149, 0.57594, 0.44491, 0.0, 0.0}, _
        New Single() {0.15752, 0.14144, 0.10929, 0.0, 0.0}, _
        New Single() {0.0, 0.0, 0.0, 1.0, 0.0}, _
        New Single() {0.001, 0.001, 0.001, 0.0, 1.0}})

        Try
            Dim rect As Rectangle = Rectangle.Round(img.GetBounds(GraphicsUnit.Pixel))
            Dim wid As Integer = img.Width
            Dim hgt As Integer = img.Height
            img = ConvertToRGB(img)
            Dim gr As Graphics = Graphics.FromImage(img)
            gr.SmoothingMode = SmoothingMode.HighQuality
            gr.CompositingQuality = CompositingQuality.HighQuality
            gr.InterpolationMode = InterpolationMode.High

            image_attr.SetColorMatrix(cmy)
            gr.DrawImage(img, rect, 0, 0, wid, hgt, GraphicsUnit.Pixel, image_attr)

            Return img
        Catch
            MessageBox.Show("Error")
        End Try
        Return img

    End Function

    Private Function Grayscale(ByVal img As Image) As Image
        Dim image_Attr As New ImageAttributes

        Dim rL As Single = 0.2225 '0.3086
        Dim gL As Single = 0.7169 '0.0694
        Dim bL As Single = 0.0606 '0.0820


        Dim cmy As ColorMatrix = New ColorMatrix(New Single()() _
            { _
            New Single() {rL, rL, rL, 0, 0}, _
            New Single() {gL, gL, gL, 0, 0}, _
            New Single() {bL, bL, bL, 0, 0}, _
            New Single() {0, 0, 0, 1, 0}, _
            New Single() {0, 0, 0, 0, 0}})
        Try
            Dim rect As Rectangle = Rectangle.Round(img.GetBounds(GraphicsUnit.Pixel))
            Dim wid As Integer = img.Width
            Dim hgt As Integer = img.Height
            img = ConvertToRGB(img)
            Dim gr As Graphics = Graphics.FromImage(img)
            gr.InterpolationMode = InterpolationMode.High
            gr.SmoothingMode = SmoothingMode.HighQuality
            gr.CompositingQuality = CompositingQuality.HighQuality

            image_Attr.SetColorMatrix(cmy)
            gr.DrawImage(img, rect, 0, 0, wid, hgt, GraphicsUnit.Pixel, image_Attr)

            Return img
        Catch
            MessageBox.Show("Error")
        End Try
        Return img
    End Function

    Private Sub ToolStripMenuItem4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem4.Click

        Application.Exit()
    End Sub

    Private Sub ToolStripMenuItem3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem3.Click
        Shell("Explorer " & AppDomain.CurrentDomain.BaseDirectory, AppWinStyle.NormalFocus)
    End Sub

    Private Sub ToolStripMenuItem1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem1.Click
        scan()
        plSelect.Enabled = True
        plDoIt.Enabled = True
        lblImages.Text = "*.Jpg Files In Folder: " & ImageArray.Count.ToString
        LoadImages()
    End Sub


    Private Function Dark(ByVal img As Image) As Image
        Dim image_Attr As New ImageAttributes
        Dim Tol As Single = CSng(tbIntensity.Value) / 128

        Dim cmy As ColorMatrix = New ColorMatrix(New Single()() _
            { _
            New Single() {Tol, 0, 0, 0, 0}, _
            New Single() {0, Tol, 0, 0, 0}, _
            New Single() {0, 0, Tol, 0, 0}, _
            New Single() {0, 0, 0, 1, 0}, _
            New Single() {0, 0, 0, 0, 1}})
        Try
            Dim rect As Rectangle = Rectangle.Round(img.GetBounds(GraphicsUnit.Pixel))
            Dim wid As Integer = img.Width
            Dim hgt As Integer = img.Height
            img = ConvertToRGB(img)
            Dim gr As Graphics = Graphics.FromImage(img)
            gr.SmoothingMode = SmoothingMode.HighQuality
            gr.CompositingQuality = CompositingQuality.HighQuality
            gr.InterpolationMode = InterpolationMode.High

            image_Attr.SetColorMatrix(cmy)
            gr.DrawImage(img, rect, 0, 0, wid, hgt, GraphicsUnit.Pixel, image_Attr)

            Return img
        Catch
            MessageBox.Show("Error")
        End Try
        Return img
    End Function

    Private Sub ckDark_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckDark.CheckedChanged
        If ckDark.Checked = True Then

            tbIntensity.Visible = True
        Else
            tbIntensity.Visible = False
        End If

    End Sub
    Private Sub btnExtract_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExtract.Click
        Rip(NameToUse)
        pbPreview.Visible = False
        pbSelect.Visible = True
        pbSelect.Image = Image.FromFile(ImageArray(0))
        plDoIt.Enabled = True
        plSelect.Enabled = True
        lblImages.Text = "Frames In Animation: " & ImageArray.Count.ToString
        LoadImages()
    End Sub

    Private Sub tbIntensity_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles tbIntensity.MouseEnter
        lblValue.Visible = True
    End Sub

    Private Sub tbIntensity_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles tbIntensity.MouseLeave
        lblValue.Visible = False
    End Sub

    Private Sub tbIntensity_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles tbIntensity.MouseUp
        Preview()
    End Sub

    Private Sub tbIntensity_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbIntensity.Scroll
        lblValue.Text = tbIntensity.Value.ToString
    End Sub

    Private Sub tbTolerance_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles tbTolerance.MouseEnter
        lblValue1.Visible = True
    End Sub

    Private Sub tbTolerance_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles tbTolerance.MouseLeave
        lblValue1.Visible = False

    End Sub

    Private Sub tbTolerance_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles tbTolerance.MouseUp
        Preview()
    End Sub

    Private Sub tbTolerance_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbTolerance.Scroll
        lblValue1.Text = tbTolerance.Value.ToString
    End Sub

    Private Sub btnFramePView_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFramePView.Click
        preview()
    End Sub
    Private Sub Preview()
        Dim Im As Bitmap
        Im = pbSelect.Image.Clone
        If ckDark.Checked = True Then Im = Dark(Im)
        If rbSepiaTone.Checked = True Then Im = Sepia(Im)
        If rbGrayScale.Checked = True Then Im = Grayscale(Im)
        If ckGhost.Checked = True Then Ghost(Im)
        If ckFlip.Checked = True Then Im.RotateFlip(RotateFlipType.RotateNoneFlipX)
        pbResult.Image = Im
    End Sub

    Private Sub LoadImages()
        Try
            If ImageArray Is Nothing Then
                Return
            End If

            If Me.WindowState = FormWindowState.Minimized Then
                Return
            End If
            Me.Cursor = Cursors.WaitCursor
            dataVImages.Rows.Clear()
            dataVImages.Columns.Clear()

            Dim ColumnsThatFit As Integer = (dataVImages.Width - 10) / (_imageSize + 25)
            Dim numRows As Integer = 0

            Dim ImagesToDisplay As Integer = ImageArray.Count

            numRows = CInt(Math.Ceiling(CDbl(ImageArray.Count) / CDbl(ColumnsThatFit)))

            Dim CellsForPictureNumber As Integer = numRows * ColumnsThatFit
            '  MessageBox.Show(ColumnsThatFit.ToString & "," & numRows.ToString & "," & CellsForPictureNumber.ToString)
            ' Dynamically create the columns
            For index As Integer = 0 To ColumnsThatFit - 1
                Dim dataGridViewColumn As New DataGridViewImageColumn()

                dataVImages.Columns.Add(dataGridViewColumn)
                dataVImages.Columns(index).Width = _imageSize + 20
            Next

            ' Create the rows

            For index As Integer = 0 To numRows - 1
                dataVImages.Rows.Add()
                dataVImages.Rows(index).Height = _imageSize + 20
            Next

            Dim columnIndex As Integer = 0
            Dim rowIndex As Integer = 0

            For index As Integer = 0 To (ImagesToDisplay - 1)
                ' Load the image from the file and add to the DataGridView
                Dim image As Image = Helper.ResizeImage(ImageArray(index), _imageSize, _imageSize, False)
                dataVImages.Rows(rowIndex).Cells(columnIndex).Value = image
                dataVImages.Rows(rowIndex).Cells(columnIndex).ToolTipText = "Frame-" & index.ToString & ": " & Path.GetFileName(ImageArray(index)) & " " & GetImageWidth(ImageArray(index)) & "x" & GetImageHeight(ImageArray(index))

                ' Have we reached the end column? if so then start on the next row
                If columnIndex = ColumnsThatFit - 1 Then
                    rowIndex += 1
                    columnIndex = 0
                Else
                    columnIndex += 1
                End If
            Next
            ' Blank the unused cells
            If CellsForPictureNumber > ImagesToDisplay Then
                For index As Integer = 0 To CellsForPictureNumber - ImagesToDisplay - 1
                    Dim dataGridViewCellStyle As New DataGridViewCellStyle()
                    dataGridViewCellStyle.NullValue = Nothing
                    dataGridViewCellStyle.Tag = "BLANK"
                    dataVImages.Rows(rowIndex).Cells(columnIndex + index).Style = dataGridViewCellStyle
                Next
            End If
        Catch ex As Exception
            Console.WriteLine(ex)
        End Try
        Me.Cursor = Cursors.Default
    End Sub
    Private Function GetImageHeight(ByRef file As String) As Integer
        Using image As System.Drawing.Image = System.Drawing.Image.FromFile(file)
            Return image.Height
        End Using
    End Function

    Private Function GetImageWidth(ByRef file As String) As Integer
        Using image As System.Drawing.Image = System.Drawing.Image.FromFile(file)
            Return image.Width
        End Using
    End Function


    Private Sub dataVImages_CellClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dataVImages.CellClick
        'Select Frame By Using Mouse
        Dim i, j As Integer
        i = e.RowIndex
        j = e.ColumnIndex
        Position = i * dataVImages.Columns.Count + j ' + 1  'index of imagearray
        If Position > ImageArray.Count - 1 Then Exit Sub
        pbSelect.Image = Image.FromFile(ImageArray(Position))
        lblTour.Text = ImageArray(Position) & vbNewLine & "Image(" & Position & ")"
        N = Position
        Refresh()
    End Sub



    Private Sub Hilite()
        Dim rcol, rrow As Integer
        rcol = N Mod dataVImages.Columns.Count
        '  rrow = N / dataVImages.Columns.Count
        rrow = CInt(Math.Ceiling(CDbl(N + 1) / CDbl(dataVImages.Columns.Count))) - 1
        dataVImages.CurrentCell = dataVImages(rcol, rrow)
        dataVImages.BeginEdit(True)

        '   MessageBox.Show("Col " & rcol.ToString & "  Row " & rrow.ToString)
    End Sub

    Private Sub dataVImages_CellEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dataVImages.CellEnter
        'Select Frame By Using Arrows
        Dim i, j As Integer
        i = e.RowIndex
        j = e.ColumnIndex
        Position = i * dataVImages.Columns.Count + j ' + 1  'index of imagearray
        If Position > ImageArray.Count - 1 Then Exit Sub
        pbSelect.Image = Image.FromFile(ImageArray(Position))
        lblTour.Text = ImageArray(Position) & vbNewLine & "Image(" & Position & ")"
        N = Position
        Refresh()
    End Sub

End Class
